=begin
#Payments Orchestrator

#\"REST API for Payments Orchestrator\"

The version of the OpenAPI document: 1.6.4-SNAPSHOT
Contact: test@yapstone.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

# Common files
require 'yapstone-payments/api_client'
require 'yapstone-payments/api_error'
require 'yapstone-payments/version'
require 'yapstone-payments/configuration'

# Models
require 'yapstone-payments/models/apm'
require 'yapstone-payments/models/apm_spec_in_parameters'
require 'yapstone-payments/models/action'
require 'yapstone-payments/models/address'
require 'yapstone-payments/models/amount'
require 'yapstone-payments/models/auth_response'
require 'yapstone-payments/models/auth_token_request'
require 'yapstone-payments/models/auth_token_response'
require 'yapstone-payments/models/bank_account'
require 'yapstone-payments/models/billing_address'
require 'yapstone-payments/models/booking_info'
require 'yapstone-payments/models/capture_payment_request'
require 'yapstone-payments/models/card'
require 'yapstone-payments/models/card_response'
require 'yapstone-payments/models/consent'
require 'yapstone-payments/models/credit_card_auth_response'
require 'yapstone-payments/models/customer'
require 'yapstone-payments/models/customer_data'
require 'yapstone-payments/models/customer_details'
require 'yapstone-payments/models/deposit'
require 'yapstone-payments/models/deposit_details'
require 'yapstone-payments/models/disburse_line_items_req'
require 'yapstone-payments/models/disburse_transaction'
require 'yapstone-payments/models/disburse_transaction_req'
require 'yapstone-payments/models/disbursement'
require 'yapstone-payments/models/disbursement_all_of'
require 'yapstone-payments/models/disbursement_details'
require 'yapstone-payments/models/disbursement_request'
require 'yapstone-payments/models/disbursement_requests'
require 'yapstone-payments/models/disbursement_response'
require 'yapstone-payments/models/error'
require 'yapstone-payments/models/error_response'
require 'yapstone-payments/models/fields'
require 'yapstone-payments/models/gov_identification'
require 'yapstone-payments/models/guest'
require 'yapstone-payments/models/guest_info_response'
require 'yapstone-payments/models/href'
require 'yapstone-payments/models/inline_response200'
require 'yapstone-payments/models/installment_plan'
require 'yapstone-payments/models/instrument'
require 'yapstone-payments/models/instrument_verification_response'
require 'yapstone-payments/models/kyc'
require 'yapstone-payments/models/lease_info'
require 'yapstone-payments/models/line_item_details'
require 'yapstone-payments/models/marketplace_data'
require 'yapstone-payments/models/merketplace'
require 'yapstone-payments/models/money'
require 'yapstone-payments/models/name'
require 'yapstone-payments/models/offering_details'
require 'yapstone-payments/models/order_transactions'
require 'yapstone-payments/models/payment'
require 'yapstone-payments/models/payment_cancel_response'
require 'yapstone-payments/models/payment_cancel_transaction_response'
require 'yapstone-payments/models/payment_details'
require 'yapstone-payments/models/payment_instrument'
require 'yapstone-payments/models/payment_instrument_card'
require 'yapstone-payments/models/payment_instrument_response'
require 'yapstone-payments/models/payment_payment'
require 'yapstone-payments/models/payment_payment_all_of'
require 'yapstone-payments/models/payment_response'
require 'yapstone-payments/models/phone'
require 'yapstone-payments/models/process_payment'
require 'yapstone-payments/models/property_info'
require 'yapstone-payments/models/property_info_response'
require 'yapstone-payments/models/refund_action'
require 'yapstone-payments/models/refund_cancel_response'
require 'yapstone-payments/models/refund_cancel_transaction_response'
require 'yapstone-payments/models/refund_request'
require 'yapstone-payments/models/refund_response'
require 'yapstone-payments/models/refund_status'
require 'yapstone-payments/models/refund_transactions'
require 'yapstone-payments/models/rental_info'
require 'yapstone-payments/models/renter'
require 'yapstone-payments/models/resolution'
require 'yapstone-payments/models/result'
require 'yapstone-payments/models/risk_status'
require 'yapstone-payments/models/sanctioned_entities'
require 'yapstone-payments/models/search_payment_response'
require 'yapstone-payments/models/stack_trace_element'
require 'yapstone-payments/models/status'
require 'yapstone-payments/models/throwable'
require 'yapstone-payments/models/to_entity_ref'
require 'yapstone-payments/models/token'
require 'yapstone-payments/models/token_req'
require 'yapstone-payments/models/token_request'
require 'yapstone-payments/models/token_response'
require 'yapstone-payments/models/transaction'
require 'yapstone-payments/models/transaction_response'
require 'yapstone-payments/models/triggers'
require 'yapstone-payments/models/vacation_rental_info'
require 'yapstone-payments/models/vacation_rental_info_request'
require 'yapstone-payments/models/verify_instrument_request'

# APIs
require 'yapstone-payments/api/authentication_api'
require 'yapstone-payments/api/disbursements_api'
require 'yapstone-payments/api/payments_api'
require 'yapstone-payments/api/refunds_api'
require 'yapstone-payments/api/search_api'
require 'yapstone-payments/api/token_api'

module Yapstone
  class << self
    # Customize default settings for the SDK using block.
    #   Yapstone.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
