=begin
#Payments Orchestrator

#\"REST API for Payments Orchestrator\"

The version of the OpenAPI document: 1.6.4-SNAPSHOT
Contact: test@yapstone.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  # Captures booking information for a booking payment 
  class BookingInfo
    # ISO 8601 date of the guest's check in. 
    attr_accessor :checkin_date

    # ISO 8601 date of the guest's check out. 
    attr_accessor :checkout_date

    attr_accessor :nightly_rate

    # Number of adults who will be staying in this booking. 
    attr_accessor :number_of_adults

    # Number of children who will be staying in this booking. 
    attr_accessor :number_of_children

    # Number of nights that the guests will be staying. 
    attr_accessor :number_of_nights

    # Your system's reservation number for this booking. 
    attr_accessor :reservation_number

    attr_accessor :nightly_tax

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'checkin_date' => :'checkinDate',
        :'checkout_date' => :'checkoutDate',
        :'nightly_rate' => :'nightlyRate',
        :'number_of_adults' => :'numberOfAdults',
        :'number_of_children' => :'numberOfChildren',
        :'number_of_nights' => :'numberOfNights',
        :'reservation_number' => :'reservationNumber',
        :'nightly_tax' => :'nightlyTax'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'checkin_date' => :'String',
        :'checkout_date' => :'String',
        :'nightly_rate' => :'Amount',
        :'number_of_adults' => :'Integer',
        :'number_of_children' => :'Integer',
        :'number_of_nights' => :'Integer',
        :'reservation_number' => :'String',
        :'nightly_tax' => :'Amount'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::BookingInfo` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::BookingInfo`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'checkin_date')
        self.checkin_date = attributes[:'checkin_date']
      end

      if attributes.key?(:'checkout_date')
        self.checkout_date = attributes[:'checkout_date']
      end

      if attributes.key?(:'nightly_rate')
        self.nightly_rate = attributes[:'nightly_rate']
      end

      if attributes.key?(:'number_of_adults')
        self.number_of_adults = attributes[:'number_of_adults']
      end

      if attributes.key?(:'number_of_children')
        self.number_of_children = attributes[:'number_of_children']
      end

      if attributes.key?(:'number_of_nights')
        self.number_of_nights = attributes[:'number_of_nights']
      end

      if attributes.key?(:'reservation_number')
        self.reservation_number = attributes[:'reservation_number']
      end

      if attributes.key?(:'nightly_tax')
        self.nightly_tax = attributes[:'nightly_tax']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          checkin_date == o.checkin_date &&
          checkout_date == o.checkout_date &&
          nightly_rate == o.nightly_rate &&
          number_of_adults == o.number_of_adults &&
          number_of_children == o.number_of_children &&
          number_of_nights == o.number_of_nights &&
          reservation_number == o.reservation_number &&
          nightly_tax == o.nightly_tax
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [checkin_date, checkout_date, nightly_rate, number_of_adults, number_of_children, number_of_nights, reservation_number, nightly_tax].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
