=begin
#Payments Orchestrator

#\"REST API for Payments Orchestrator\"

The version of the OpenAPI document: 1.6.4-SNAPSHOT
Contact: test@yapstone.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  # The PaymentResponse schema provides details about a payment that enable you to track the payment and refer to it easily 
  class PaymentResponse
    # The action that was taken for this phase of the payment. 
    attr_accessor :action

    # Optionally provide your system's internal identifier for this entity, for use later if you need to correlate data across systems or consolidate records. 
    attr_accessor :client_correlation_id

    # This is the unique transaction ID for one transaction to do with a payment being processed. You can use this to retrieve a specific transaction vs. a set of associated transactions (which is what you would use the clientCorrelationId for). 
    attr_accessor :client_unique_transaction_id

    # The payment ID allows you to reference the payment if you need to cancel it or retrieve it. 
    attr_accessor :payment_id

    attr_accessor :payment

    attr_accessor :customer

    attr_accessor :marketplace

    attr_accessor :custom_data

    attr_accessor :refund_id

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'action' => :'action',
        :'client_correlation_id' => :'clientCorrelationId',
        :'client_unique_transaction_id' => :'clientUniqueTransactionId',
        :'payment_id' => :'paymentId',
        :'payment' => :'payment',
        :'customer' => :'customer',
        :'marketplace' => :'marketplace',
        :'custom_data' => :'customData',
        :'refund_id' => :'refundId'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'action' => :'String',
        :'client_correlation_id' => :'String',
        :'client_unique_transaction_id' => :'String',
        :'payment_id' => :'String',
        :'payment' => :'Payment',
        :'customer' => :'CustomerDetails',
        :'marketplace' => :'Merketplace',
        :'custom_data' => :'Hash<String, String>',
        :'refund_id' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::PaymentResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::PaymentResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'action')
        self.action = attributes[:'action']
      end

      if attributes.key?(:'client_correlation_id')
        self.client_correlation_id = attributes[:'client_correlation_id']
      end

      if attributes.key?(:'client_unique_transaction_id')
        self.client_unique_transaction_id = attributes[:'client_unique_transaction_id']
      end

      if attributes.key?(:'payment_id')
        self.payment_id = attributes[:'payment_id']
      end

      if attributes.key?(:'payment')
        self.payment = attributes[:'payment']
      end

      if attributes.key?(:'customer')
        self.customer = attributes[:'customer']
      end

      if attributes.key?(:'marketplace')
        self.marketplace = attributes[:'marketplace']
      end

      if attributes.key?(:'custom_data')
        if (value = attributes[:'custom_data']).is_a?(Hash)
          self.custom_data = value
        end
      end

      if attributes.key?(:'refund_id')
        self.refund_id = attributes[:'refund_id']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          action == o.action &&
          client_correlation_id == o.client_correlation_id &&
          client_unique_transaction_id == o.client_unique_transaction_id &&
          payment_id == o.payment_id &&
          payment == o.payment &&
          customer == o.customer &&
          marketplace == o.marketplace &&
          custom_data == o.custom_data &&
          refund_id == o.refund_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [action, client_correlation_id, client_unique_transaction_id, payment_id, payment, customer, marketplace, custom_data, refund_id].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
