=begin
#Payments Orchestrator

#\"REST API for Payments Orchestrator\"

The version of the OpenAPI document: 1.6.4-SNAPSHOT
Contact: test@yapstone.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.1.0-SNAPSHOT

=end

require 'date'

module Yapstone
  # Details for a refund request - the amount to be refunded and the identifier for the transaction you want to arrange a refund for. 
  class RefundRequest
    # client correlation id
    attr_accessor :client_correlation_id

    # clientUniqueTransactionId used to identify duplicate request
    attr_accessor :client_unique_transaction_id

    attr_accessor :payment_id

    attr_accessor :amount

    attr_accessor :transactions

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'client_correlation_id' => :'clientCorrelationId',
        :'client_unique_transaction_id' => :'clientUniqueTransactionId',
        :'payment_id' => :'paymentId',
        :'amount' => :'amount',
        :'transactions' => :'transactions'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'client_correlation_id' => :'String',
        :'client_unique_transaction_id' => :'String',
        :'payment_id' => :'String',
        :'amount' => :'Amount',
        :'transactions' => :'Array<Transaction>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Yapstone::RefundRequest` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Yapstone::RefundRequest`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'client_correlation_id')
        self.client_correlation_id = attributes[:'client_correlation_id']
      end

      if attributes.key?(:'client_unique_transaction_id')
        self.client_unique_transaction_id = attributes[:'client_unique_transaction_id']
      end

      if attributes.key?(:'payment_id')
        self.payment_id = attributes[:'payment_id']
      end

      if attributes.key?(:'amount')
        self.amount = attributes[:'amount']
      end

      if attributes.key?(:'transactions')
        if (value = attributes[:'transactions']).is_a?(Array)
          self.transactions = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@client_correlation_id.nil? && @client_correlation_id.to_s.length > 128
        invalid_properties.push('invalid value for "client_correlation_id", the character length must be smaller than or equal to 128.')
      end

      if !@client_correlation_id.nil? && @client_correlation_id.to_s.length < 0
        invalid_properties.push('invalid value for "client_correlation_id", the character length must be great than or equal to 0.')
      end

      if !@client_unique_transaction_id.nil? && @client_unique_transaction_id.to_s.length > 128
        invalid_properties.push('invalid value for "client_unique_transaction_id", the character length must be smaller than or equal to 128.')
      end

      if !@client_unique_transaction_id.nil? && @client_unique_transaction_id.to_s.length < 0
        invalid_properties.push('invalid value for "client_unique_transaction_id", the character length must be great than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@client_correlation_id.nil? && @client_correlation_id.to_s.length > 128
      return false if !@client_correlation_id.nil? && @client_correlation_id.to_s.length < 0
      return false if !@client_unique_transaction_id.nil? && @client_unique_transaction_id.to_s.length > 128
      return false if !@client_unique_transaction_id.nil? && @client_unique_transaction_id.to_s.length < 0
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] client_correlation_id Value to be assigned
    def client_correlation_id=(client_correlation_id)
      if !client_correlation_id.nil? && client_correlation_id.to_s.length > 128
        fail ArgumentError, 'invalid value for "client_correlation_id", the character length must be smaller than or equal to 128.'
      end

      if !client_correlation_id.nil? && client_correlation_id.to_s.length < 0
        fail ArgumentError, 'invalid value for "client_correlation_id", the character length must be great than or equal to 0.'
      end

      @client_correlation_id = client_correlation_id
    end

    # Custom attribute writer method with validation
    # @param [Object] client_unique_transaction_id Value to be assigned
    def client_unique_transaction_id=(client_unique_transaction_id)
      if !client_unique_transaction_id.nil? && client_unique_transaction_id.to_s.length > 128
        fail ArgumentError, 'invalid value for "client_unique_transaction_id", the character length must be smaller than or equal to 128.'
      end

      if !client_unique_transaction_id.nil? && client_unique_transaction_id.to_s.length < 0
        fail ArgumentError, 'invalid value for "client_unique_transaction_id", the character length must be great than or equal to 0.'
      end

      @client_unique_transaction_id = client_unique_transaction_id
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          client_correlation_id == o.client_correlation_id &&
          client_unique_transaction_id == o.client_unique_transaction_id &&
          payment_id == o.payment_id &&
          amount == o.amount &&
          transactions == o.transactions
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [client_correlation_id, client_unique_transaction_id, payment_id, amount, transactions].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Yapstone.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
